/* hoc6.h */

typedef struct Symbol               /* Symbol table */
{   char    *name;
    short   type;
    union
    {	double	val;		/* VAR */
        double  (*ptr)();	/* BLTIN */
        int     (*defn)();      /* FUNCTION, PROCEDURE */
        char    *str;           /* STRING */
    } u;
    struct Symbol *next;	/* Zeiger zum naechsten in der Liste */
} Symbol;

Symbol *install(char *s, int t, double d);
Symbol *lookup(char *s);


typedef union Datum                /* Interpreter Stack element */
{   double  val;
    Symbol  *sym;
} Datum;

extern Datum pop();

typedef int (*Inst)();              /* Machine Command */
#define STOP (Inst) 0

extern Inst prog[],*progbase, *progp, *code();

extern eval(), add(), sub(), mul(), ddiv(), negate(), power(), mod();
extern assign(), bltin(), varpush(), constpush(), print(), varread();
extern prexpr(), prstr();
extern gt(), ge(), lt(), le(), eq(), ne(), and(), or(), not();
extern ifcode(), whilecode(), call(), arg(), argassign();
extern funcret(), procret();

#if 0
/* from code.c */
extern void initcode();
extern void push(Datum d);
extern Datum pop();
extern Inst *code(Inst f);
extern void execute(Inst *p);
extern void constpush();
extern void varpush();
extern void add();
extern void sub();
extern void mul();
extern void ddiv();
extern void power();
extern void negate();
extern void eval();
extern void assign();
extern void print();
extern void bltin();
#endif


