/* -*-c-*- */
%{
#include "hoc6.h"
#include "y.tab.h"
#include <stdio.h>
extern int lineno;
%}

%%
[ \t]+  { ; } /* ignore TAB, SPC */
#[^\n]* { ; } /* ignore comments */
<<EOF>> { 	printf("\nBye ...\n");
			return 0;
		}
[0-9]+\.?|[0-9]*\.[0-9]+|[0-9]+("."[0-9]*)?"e"[+-]?[0-9]+|("."[0-9]+)?"e"[+-]?[0-9]+ { /* numbers */
    	double d;
		sscanf(yytext, "%lf", &d); 
		yylval.sym = install("", NUMBER, d);
		return NUMBER; 
	}	
[a-zA-Z][a-zA-Z_0-9]* { 
		Symbol *s; 		
	    if (strlen(yytext)>100)
		{	execerror("name too long:",yytext);
		}
		if ((s=lookup(yytext)) == 0) 
		{ 	s = install(yytext, UNDEF, 0.0); 
		} 
		yylval.sym = s; 

		return (s->type == UNDEF) ? VAR : s->type; 
	}
\"[^"\n]*\" { /*" this cannot handle \" in strings!!! */
		char sbuf[BUFSIZ];

	    if (strlen(yytext)>=BUFSIZ)
		{	execerror("string too long:",yytext);
		}
        strncpy(sbuf,yytext,BUFSIZ-1);
        /* escape '\' im strings here */
        dq_backslash(sbuf);

		yylval.sym = (Symbol *)emalloc(strlen(sbuf)+1);
		strcpy((char *)yylval.sym, sbuf);
		return STRING;
	}
"$"[0-9]+ { /* references to argment list in func definition */
		long n=0;

		sscanf(yytext, "$%ld", &n);

		if (n <= 0)
			execerror("strange $...",(char *)0);
        yylval.narg = n;
		return ARG;
	}
">=" { return GE;  }
">"  { return GT;  }
"<=" { return LE;  }
"<"  { return LT;  }
"==" { return EQ;  }
"!=" { return NE;  }
"!"  { return NOT; }
"||" { return OR;  }
"&&" { return AND; }
";"  { return '\n'; }
"\n" { lineno++; return '\n'; }
.    { return yytext[0]; }

%{
%}











