/* symbol.c */
#include "hoc6.h"
#include "y.tab.h"
#include <string.h>

static Symbol *symlist=0;	/* Start symbol-table */

Symbol *lookup(char *s)		/* find Symbol s in table */
{   Symbol  *sp;
    
    for(sp=symlist; sp!=(Symbol *)0; sp=sp->next)
	if(strcmp(sp->name, s) == 0)
	    return sp;
    return 0;			/* not found */
}

                                /* add new symbol to list */
Symbol *install(char *s, int t, double d)
{   Symbol  *sp;
    char    *emalloc(unsigned n);

    sp = (Symbol *)emalloc(sizeof(Symbol));
    sp->name = (char *)emalloc(strlen(s)+1);
    strcpy(sp->name,s);
    sp->type = t;
    sp->u.val = d;
    sp->next = symlist;
    symlist = sp;

    return sp;
}

char    *emalloc(unsigned n)
{   char    *p;
    
    if((p = (char *)malloc(n)) == 0)
	execerror("out of memory",(char *)0);

    return p;
}

